//Copyright (c) 1997 Brian and Aidan Cully
//All rights reserved

#ifndef __CONIC_H
#define __CONIC_H

#include "LTypes.h"
#include "Angle.h"
#include "CLMessenger.h"

#define CONICPARTS 80

class TPlane:
	public MMessenger
{
protected:
	float mPDis;
	void CalcNormal();
	TAngle mPAng;
	p3d *mAPlane;
public:
	p3d *mPlane;
	p3d mPNorm;
	TPlane();
	~TPlane();
	void Init();
	void Kill();
	void SetDistance( float dis );
	float GetDistance() {return( mPDis );};
	void SetAngle( float );
	float GetAngle() {return(mPAng.GetAngle());};
	float GetSinAngle() {return(mPAng.GetSinAngle());};
	float GetCosAngle() {return(mPAng.GetCosAngle());};
	void RotPlane();
};

class TConic {
protected:
	p3d *mAConic;
public:
	int mNumInt, *mIntersect;
	p3d *mConic;
	TConic();
	~TConic();
	void Init();
	void Kill();
	void CalcIntersect( const TPlane & );
};

#endif