//Copyright (c) 1997 Aidan Cully
//All rights reserved

#ifndef __CONICORIENTATION_H
#define __CONICORIENTATION_H

#include "Conic.h"
#include "CLPicControl.h"

enum TConicOrientation
{
	kOrientationPlaneClockwise = 0,
	kOrientationPlaneCounter = 1,
	kOrientationPlaneIn = 2,
	kOrientationPlaneOut = 3,
	kOrientationYawLeft = 4,
	kOrientationYawRight = 5,
	kOrientationPitchForward = 6,
	kOrientationPitchBack = 7
};

class TViewManagerHolder:
	public TLayoutBranch
{
protected:
	virtual void BuildChildren();
	TConic *mConic;
	TPlane *mPlane;
public:
	TViewManagerHolder( TLayoutBranch*, TConic*, TPlane* );
};

class TConicViewManager:
	public TPicControl
{
protected:
	int mOrientation;
	TConic *mConic;
	TPlane *mPlane;
	UInt32 mPrevTime;
	virtual void TrackMouseWithin( TMouseEvent* );
	virtual void TrackMouseChange( TMouseEvent*, Boolean );
	virtual void TrackMouseDown( TMouseEvent* );
public:
	TConicViewManager( TLayoutBranch*, SInt16, TConic*, TPlane*, int );
};

#endif