
#define MAX_PAIRS 5000
#define MAX_GEN 10

#include "lotto_data_class.h"

typedef struct pair {
	int PAIR_1;
	int PAIR_2;
	int pair_count;
	bool used;
} a_pair;

typedef struct calc_data {
	int set[6];
	int protect[6];
	int distrib[6];
	int reds;
	int whites;
	int blues;
	int evens;
	int odds;
} calc_array;

typedef struct set1 {
	int the_set[6];
} a_set;

class lotto_calc : public lotto_data {

   friend bool read_file( void );
   friend void clear_records( void );
   friend bool update_struct_file( void );
   friend bool edit_struct_file( void );
   friend void simple_save( void );
	
	public:
		
		a_set *p_set;
		int TEST_1;
		int TEST_2;
		a_pair *thePair[MAX_PAIRS];
		calc_array *array10[MAX_GEN];
		int num_of_pairs;
		int ten_hot_pairs[10][3];
		int zeros[52];
		int the_user_request;
		int last_hot_pair;

		bool make_numbers( int );
		bool predict_set( void );
		
		
	private:
		
		int get_rollover( void );
		void check_missing_numbers( int );
		bool verify_sets( int );
		bool check_if_valid_sets( int );
		void clear_stats( int );
		void reset_last_hot_pair( int );
		void clear_array10( int );
		bool check_against_database( int );
		bool is_funky( int );
		void get_hot_pairs( void );
		bool record_pair( int, int, int );
		void bubble_sort_pairs( void );
		void get_ten_best_pairs( void );
		bool get_zero_dists( void );
		void delete_pair_structs( void );
		void bubble_sort_sets( int );
		int  pick_zero_dist( void );
		bool check_if_good_num( int, int );
		bool check_if_good_set( int, int );
		bool get_a_hot_pair( int );
		void get_calc_stats( int );
		bool is_red( int );
		bool is_white( int );
		bool is_blue( int );
		bool is_odd( int );
		bool is_even( int );
		bool check_matrix( int );
		bool recheck_sets( int );
		bool check_for_too_many( int );
		bool check_last_two_lows( void );
};

